---
title: FileSystemEntry.copyTo()
slug: Web/API/FileSystemEntry/copyTo
tags:
  - API
  - File System API
  - File and Directory Entries APIs
  - FileSystemEntry
  - Files
  - Method
  - Non-standard
  - Reference
  - copyTo
---
<p>{{APIRef("File System API")}}{{Obsolete_Header}}</p>

<p><span class="seoSummary">The {{domxref("FileSystemEntry")}} interface's method <code><strong>copyTo</strong></code><strong><code>()</code></strong> copies the file specified by the entry to a new location on the file system.</span> There are some typical restrictions on what you can do:</p>

<ul>
 <li>A directory can't be copied into itself.</li>
 <li>An entry can't be copied into its parent directory unless you specify a new name.</li>
 <li>When copying a directory, the copy is always recursive; you can't leave out subfolders.</li>
</ul>

<h2 id="Syntax">Syntax</h2>

<pre class="syntaxbox"><em>FileSystemEntry</em>.copyTo(<em>newParent</em>[, <em>newName</em>][, <em>successCallback</em>][, <em>errorCallback</em>]);</pre>

<h3 class="syntaxbox" id="Parameters">Parameters</h3>

<dl>
 <dt><code>newParent</code></dt>
 <dd>A {{domxref("FileSystemDirectoryEntry")}} object specifying the destination directory for the copy operation.</dd>
 <dt><code>newName</code> {{optional_inline}}</dt>
 <dd>If this parameter is provided, the copy is given this string as its new file or directory name.</dd>
 <dt><code>successCallback</code> {{optional_inline}}</dt>
 <dd>A function which is called when the copy operation is succesfully completed. Receives a single input parameter: a {{domxref("FileSystemEntry")}} based object providing the copied item's new details.</dd>
 <dt><code>errorCallback</code> {{optional_inline}}</dt>
 <dd>An optional callback which is executed if an error occurs while copying the items. There's a single parameter: a {{domxref("FileError")}} describing what went wrong.</dd>
</dl>

<h3 id="Return_value">Return value</h3>

<p>{{jsxref("undefined")}}.</p>

<h3 id="Errors">Errors</h3>

<dl>
 <dt><code>FileError.INVALID_MODIFICATION_ERR</code></dt>
 <dd>The requested operation involves an impossible change, such as moving a directory inside itself or one of its own child directories, or copying an item within the same directory without renaming it.</dd>
 <dt><code>FileError.QUOTA_EXCEEDED_ERR</code></dt>
 <dd>The operation exceeded the user's storage quota, or there isn't enough storage space left to complete the operation.</dd>
</dl>

<h2 id="Example">Example</h2>

<p>This example shows how a temporary log file might be moved into a more permanent "log" directory.</p>

<pre class="brush: js">workingDirectory.getFile("tmp/log.txt", {}, function(fileEntry) {
  workingDirectory.getDirectory("log", {}, function(dirEntry) {
    fileEntry.copyTo(dirEntry);
  }, handleError);
}, handleError);</pre>

<h2 id="Browser_compatibility">Browser compatibility</h2>

<p>{{Compat("api.FileSystemEntry.copyTo")}}</p>

<h2 id="See_also">See also</h2>

<ul>
 <li><a href="/en-US/docs/Web/API/File_and_Directory_Entries_API">File and Directory Entries API</a></li>
 <li><a href="/en-US/docs/Web/API/File_and_Directory_Entries_API/Introduction">Introduction to the File System API</a></li>
</ul>
